--- src/Mono.WebServer.FastCgi/Record.cs.orig	2011-04-14 21:39:39.000000000 +0200
+++ src/Mono.WebServer.FastCgi/Record.cs	2013-02-26 21:04:54.229859320 +0100
@@ -279,9 +279,14 @@
 			
 			int total = 0;
 			while (total < length) {
-				total += socket.Receive (data, total,
+				int read = socket.Receive (data, total,
 					length - total,
 					System.Net.Sockets.SocketFlags.None);
+					
+				if (read == 0)
+					throw new System.Net.Sockets.SocketException();
+					
+				total += read;
 			}
 		}
 		
@@ -292,9 +297,14 @@
 			
 			int total = 0;
 			while (total < length) {
-				total += socket.Send (data, total,
+				int written = socket.Send (data, total,
 					length - total,
 					System.Net.Sockets.SocketFlags.None);
+					
+				if (written == 0)
+					throw new System.Net.Sockets.SocketException();
+					
+				total += written;
 			}
 		}
 		
